apiVersion: apps/v1
kind: Deployment
metadata:
  name: camunda-spa
  namespace: {{ .Release.Namespace }}
spec:
  selector:
    matchLabels:
      app: camunda-spa-container
  template:
    metadata:
      labels:
        app: camunda-spa-container
    spec:
      initContainers:
        - name: init-db
          #image: registry.gitlab.com/openkonsequenz/qa/statementpublicaffairs.backend/master/spa-db-init:latest
          image: "{{ .Values.imageDatabase.repository }}:{{ .Values.imageDatabase.tag }}"
          imagePullPolicy: Always
          env:
            - name: APP_DB_ROLE
              value: spa_service
            - name: APP_DBNAME
              value: spa_service_{{ .Values.shortNameEnv | lower }}
            - name: PGHOST
              value: postgresql-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local
            - name: PGUSER
              value: postgres
            - name: PGPASSWORD
              valueFrom:
                secretKeyRef:
                  name: postgresql-secrets
                  key: POSTGRES_DB_PASSWORD
          command:
            - /bin/sh
            - -c
            - |
              printenv
              echo Waiting for DB to be ready...;
              while ! pg_isready >dev/null; do sleep 3; done;
              echo DB is ready and accepting conncetions;
              sleep 3;
              {{- if .Values.resetDBonDeploy -}}
              echo ------------------------------------------------------------------------;
              echo Dropping active connections to database ${APP_DBNAME};
              psql -c "SELECT pg_terminate_backend(pg_stat_activity.pid) FROM pg_stat_activity WHERE pg_stat_activity.datname = '${APP_DBNAME}' AND pid <> pg_backend_pid()";
              echo Dropping database ${APP_DBNAME} if exists;
              psql -c "DROP DATABASE IF EXISTS \"${APP_DBNAME}\"";
              echo Dropping user ${APP_DB_ROLE} if exists;
              psql -c "DROP USER IF EXISTS \"${APP_DB_ROLE}\"";
              {{- end -}}
              echo ------------------------------------------------------------------------;
              echo Creating role ${APP_DB_ROLE} if not exists;
              psql -tc "SELECT 1 FROM pg_user WHERE usename = '${APP_DB_ROLE}'" | grep -q 1 || psql -c "CREATE USER \"${APP_DB_ROLE}\" WITH PASSWORD '${APP_DB_ROLE}'";
              echo Creating database ${APP_DBNAME} if not exists;
              psql -tc "SELECT 1 FROM pg_database WHERE datname = '${APP_DBNAME}'" | grep -q 1 || psql -U postgres -c "CREATE DATABASE \"${APP_DBNAME}\"";
              echo ------------------------------------------------------------------------;
              echo Creating tables on database ${APP_DBNAME} if not exits;
              PGPASSWORD=${APP_DB_ROLE};
              sed -i 's/--dbname "spa_service"/--dbname "${APP_DBNAME}"/g' /docker-entrypoint-initdb.d/02_create_tables.sh;
              psql -U ${APP_DB_ROLE} -d ${APP_DBNAME} -tc "select count(*) from information_schema.tables where table_schema = 'public' and table_name like 'tbl_%'" | grep 0 && /docker-entrypoint-initdb.d/02_create_tables.sh
              echo ------------------------------------------------------------------------;
              echo Job finished;
      containers:
        - image: "{{ .Values.image.repository }}:{{ .Values.image.tag }}"
          imagePullPolicy: Always
          name: camunda-spa-container
          env:
            - name: DB_DRIVER
              value: org.postgresql.Driver
            - name: DB_URL
              value: jdbc:postgresql://postgresql-svc.{{ .Values.sharedEnvironment }}.svc.cluster.local:5432/spa_service_{{ .Values.shortNameEnv | lower }}
            - name: DB_USERNAME
              value: spa_service
            - name: DB_PASSWORD
              value: spa_service
          ports:
            - containerPort: 8080
---
apiVersion: v1
kind: Service
metadata:
  name: camunda-spa-service
  namespace: {{ .Release.Namespace }}
spec:
  selector:
    app: camunda-spa-container
  ports:
    - protocol: TCP
      port: 8080
      targetPort: 8080